'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = wasMutated;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodashCollectionAny = require('lodash/collection/any');

var _lodashCollectionAny2 = _interopRequireDefault(_lodashCollectionAny);

function wasMutated(stateRef, state, isImmutable) {
  var path = arguments.length <= 3 || arguments[3] === undefined ? [] : arguments[3];

  if (isImmutable(stateRef) || isImmutable(state)) {
    if (stateRef !== state) {
      return { wasMutated: true, path: path };
    } else {
      return { wasMutated: false };
    }
  }

  var keys = {};
  Object.keys(stateRef).forEach(function (key) {
    keys[key] = true;
  });
  Object.keys(state).forEach(function (key) {
    keys[key] = true;
  });

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Object.keys(keys)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var key = _step.value;

      var result = wasMutated(stateRef[key], state[key], isImmutable, path.concat(key));
      if (result.wasMutated) {
        return result;
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator['return']) {
        _iterator['return']();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return { wasMutated: false };
}

module.exports = exports['default'];